<script setup lang="ts">
import Flex from "@/components/atoms/container/Flex.vue";
import type MergeRequestDependencyInterface from "@/entities/MergeRequest/MergeRequestDependencyInterface";
import {ref, watch} from "vue";
import AutoComplete from 'primevue/autocomplete';
import ExternalLink from "@/components/atoms/link/ExternalLink.vue";
import type Shortcut from "@/entities/Shortcut/Shortcut";
import {useShortcutsListenerStore} from "@/stores/Shortcuts/ShortcutsListenerStore";

const props = defineProps<{
  dependencyType: String,
  searchDependencyForQuery: Function,
  disabled: undefined | Boolean,
  updateDependencyHandler: undefined | Function,
  shortcut?: null|Shortcut,
  hasFocus: boolean,
}>()

const shortcutsListener = useShortcutsListenerStore();

const dependencies = defineModel('dependencies')
const searchResult = ref([]);
const select = ref();

function focusDependenciesSelect(event: KeyboardEvent) {
  if (props.shortcut?.isValidEvent(event)) {
    select.value.$refs.dropdownButton.click();
    select.value.$refs.focusInput.focus();
  }
}

const addShortcutEventListener = () => {
  if (props.shortcut) {
    if (props.hasFocus) {
      shortcutsListener.addListener(focusDependenciesSelect)
    } else {
      shortcutsListener.removeListener(focusDependenciesSelect)
    }
  }
}

watch(() => props.hasFocus, addShortcutEventListener)

const search = (event) => {
  if (!props.searchDependencyForQuery) {
    return;
  }

  props.searchDependencyForQuery(event.query).then((searchResultTemp: Array<MergeRequestDependencyInterface>) => {
    const searchedResultPerRepository = [];

    for (const searchResult of searchResultTemp) {
      const searchedRepo = searchResult.repository;

      if (!searchedRepo) {
        continue;
      }

      let found = false;

      for (const repository of searchedResultPerRepository) {
        if (repository.code === searchedRepo.code) {
          repository.results.push(searchResult);
          found = true;
          break;
        }
      }

      if (found) {
        continue;
      }

      searchedResultPerRepository.push({
        code: searchedRepo.code,
        name: searchedRepo.name,
        results: [searchResult]
      })
    }

    searchResult.value = searchedResultPerRepository;
  });

}
</script>

<template>
  <Flex class="gap-text flex-col">
    <span>Dépendances {{ dependencyType ? '(' + dependencyType + ') ' : '' }}:</span>
    <ul v-if="disabled">
      <li :key="dependency.identifier" v-for="(dependency) of dependencies">
        <ExternalLink
            :href="dependency.link"
            :title="dependency.toString()"
        >
          #{{ dependency.name }}
        </ExternalLink>
      </li>
    </ul>

    <AutoComplete
        v-model="dependencies"
        dropdown multiple
        :suggestions="searchResult"
        @complete="search"
        @change="() => updateDependencyHandler ? updateDependencyHandler() : null"
        optionGroupChildren="results"
        optionGroupLabel="name"
        optionLabel="name"
        v-else
        ref="select"
    >
      <template #chip="value: {value: MergeRequestDependencyInterface}">
        <ExternalLink
            :key="value.value.identifier"
            :href="value.value.link"
            :title="value.value.toString()"
        >
          {{ value.value.name }}
        </ExternalLink>
      </template>
    </AutoComplete>
  </Flex>
</template>
